use bevy::{prelude::*, utils::HashSet};

use super::physics::Pos;

pub struct GenerationPlugin;

impl Plugin for GenerationPlugin {
	fn build(&self, app: &mut bevy::prelude::App) {
		app.insert_resource(GeneratedRegistry::default())
			// .add_systems(schedule, systems)
            ;
	}
}

fn chunk_loading(cmd: &mut Commands, loaders: Query<&Pos, With<Loader>>, reg: ResMut<GeneratedRegistry>) {
	for pos in &loaders {
		chunks_surrounding(&pos.pos());
	}
}

const CHUNK_WIDTH: i32 = 8;

fn chunks_surrounding(pos: &IVec2) -> Vec<IVec2> {
	todo!()
}

fn snap(value: i32, increment: i32) -> i32 {
	todo!()
}

#[test]
fn test_snap() {
	// assert_eq!();
}

#[derive(Debug, Resource, Default)]
pub struct GeneratedRegistry(HashSet<IVec2>);

#[derive(Debug, Component)]
pub struct Loader;

#[derive(Debug, Component)]
pub struct Generated;

#[derive(Debug, Component)]
pub struct Chunk(IVec2);
